Loading...
Searching...
No Matches
Opm::BlackOilLocalResidual< TypeTag > Class Template Reference

Calculates the local residual of the black oil model. More...

`#include <blackoillocalresidual.hh>`

Inheritance diagram for Opm::BlackOilLocalResidual< TypeTag >:

## Public Member Functions

template<class LhsEval>
void | computeStorage (Dune::FieldVector< LhsEval, numEq > &storage, const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx) const
| Evaluate the amount all conservation quantities (e.g.
void | computeFlux (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx) const
| Evaluates the total mass flux of all conservation quantities over a face of a sub-control volume.
void | computeSource (RateVector &source, const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx) const
| Calculate the source term of the equation.

## Static Public Member Functions

template<class UpEval, class FluidState>
static void | evalPhaseFluxes_ (RateVector &flux, unsigned phaseIdx, unsigned pvtRegionIdx, const ExtensiveQuantities &extQuants, const FluidState &upFs)
| Helper function to calculate the flux of mass in terms of conservation quantities via specific fluid phase over a face.
template<class Scalar>
static void | adaptMassConservationQuantities_ (Dune::FieldVector< Scalar, numEq > &container, unsigned pvtRegionIdx)
| Helper function to convert the mass-related parts of a Dune::FieldVector that stores conservation quantities in terms of "surface-volume" to the conservation quantities used by the model.

## Detailed Description

template<class TypeTag>
class Opm::BlackOilLocalResidual< TypeTag >

Calculates the local residual of the black oil model.

## Member Function Documentation

## adaptMassConservationQuantities_()

template<class TypeTag>
template<class Scalar>

void Opm::BlackOilLocalResidual< TypeTag >::adaptMassConservationQuantities_ | ( | Dune::FieldVector< Scalar, numEq > & | container,
|  | unsigned | pvtRegionIdx )

inline static

Helper function to convert the mass-related parts of a Dune::FieldVector that stores conservation quantities in terms of "surface-volume" to the conservation quantities used by the model.

Depending on the value of the BlackoilConserveSurfaceVolume property, the model either conserves mass by means of "surface volume" of the components or mass directly. In the former case, this method is a no-op; in the latter, the values passed are multiplied by their respective pure component's density at surface conditions.

## computeFlux()

template<class TypeTag>

void Opm::BlackOilLocalResidual< TypeTag >::computeFlux | ( | RateVector & | flux,
|  | const ElementContext & | elemCtx,
|  | unsigned | scvfIdx,
|  | unsigned | timeIdx ) const

inline

Evaluates the total mass flux of all conservation quantities over a face of a sub-control volume.

## computeSource()

template<class TypeTag>

void Opm::BlackOilLocalResidual< TypeTag >::computeSource | ( | RateVector & | source,
|  | const ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | timeIdx ) const

inline

Calculate the source term of the equation.

## computeStorage()

template<class TypeTag>
template<class LhsEval>

void Opm::BlackOilLocalResidual< TypeTag >::computeStorage | ( | Dune::FieldVector< LhsEval, numEq > & | storage,
|  | const ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | timeIdx ) const

inline

Evaluate the amount all conservation quantities (e.g.

phase mass) within a finite sub-control volume.

The documentation for this class was generated from the following file:

- opm/models/blackoil/blackoillocalresidual.hh